//Prova per una call

import analyzer.record.ARecordOnLine;

import com.lauterbach.trace32.api.Trace32API;
import com.lauterbach.trace32.api.Trace32Exception;

public class ProvaCall {
	
	
	
	public static boolean isCall(ARecordOnLine r) {
		
		byte[] b=new byte[8];
		
		
		//mi copio il buffer del bus_data
		System.arraycopy(r.getBusData(),0,b,0,8);
		
		if ((b[4]==0) && (b[5]==0) ) {
			//allora e' una call
			//System.out.print("E' UNA ***CALL***");
			return true;
		} else
			return false;
				
	}
	
	/**
	 * @param args
	 * @throws Trace32Exception 
	 */
	public static void main(String[] args) throws Trace32Exception {
		
		Trace32API t32;
		t32 = Trace32API.getTrace32API(20000);
		int i=0;
		int MASSIMO=2000;
		long ind=0;
		//long data;
		long next_ind;
		long start_timestamp;
		long end_timestamp;
		long tempo_click;
		double tempo_ns, tempo_ms;
		String salto="";
		
		t32.stepMode(2);
		t32.command("break.set 6AC");
		t32.go();
		for(i=1;i<=MASSIMO;i++) {
			// resetto la finestra del trace
			t32.command("trace.reset");
						
			
			t32.Step();
			ARecordOnLine rec=new ARecordOnLine(-1);
			
			ind=rec.getPAddress();
			//data=rec.getBusData();
			next_ind=ind+rec.getBusWidth();
			int acc_class=rec.getAccessClass();
			if ( (acc_class==2) && (ProvaCall.isCall(rec)) ){
				System.out.println("=========================================================");
				//System.out.print("P: ");
				System.out.print("0x"+Long.toHexString(ind)+"\t");
				System.out.print("call ");
				System.out.print("0x");
				//String salto=Long.toHexString(data);
				System.out.print(salto.substring(13,16));
				System.out.print(" il successivo indirizzo : 0x"+Long.toHexString(next_ind)+" ");
					//System.out.print(" Invio: "+"break.set "+Long.toHexString(next_ind));
					start_timestamp=rec.getTimestamp();
					t32.command("break.set "+Long.toHexString(next_ind));
					t32.go();
					
					//prendo l'istruzione successiva alla call
					t32.Step();
					ARecordOnLine r2=new ARecordOnLine(-1);
					t32.command("trace.reset");
					ind=r2.getPAddress();
					//data=r2.getBusData();
					end_timestamp=r2.getTimestamp();
					tempo_click=end_timestamp-start_timestamp;
					tempo_ns=(tempo_click/256)*20;
					tempo_ms=(tempo_ns)/1000;
					System.out.println("\n*** IL TEMPO NECESSARIO PER LA CALL E' : "+tempo_click+"click="+tempo_ns+"ns ="+tempo_ms+"us. ********* ");
					System.out.println("=========================================================");
				//}
				//else
				//	System.out.print(" non e' una call");
				//System.out.println();
			}
		}
		
		
		
	}

}
