// Test per il collegamento con la macchina

import com.lauterbach.trace32.api.Trace32API;
import com.lauterbach.trace32.api.Trace32Exception;

/**
 * @author pierfrancesco
 *	This class is for testing Hardware Nios II
 *	
 */
public class ProvaMachine {

	/**
	 * @param args
	 * @throws Trace32Exception 
	 * @throws Trace32Exception 
	 * @throws Trace32Exception 
	 */
	public static void main(String[] args) throws Trace32Exception   {
		
		
		int port = 10000;		
								// simulator 20000
								// tracer hw 10000
		Trace32API t32;
		
			t32 = Trace32API.getTrace32API(port);
		
		
			
		
		System.out.println("*** Test for checking HARDWARE ***");
		System.out.println("Tracer port: "+port);
		
		// Ping to tracer hw
		System.out.println("Ping to tracer HW!");
		t32.ping();
		
		
		
		// read tracer state
		System.out.println("Tracer HW status: "+t32.getState());
		// read status line
		System.out.println("Status Line: "+t32.getMessage());
		
		// another ping
		System.out.println("Ping to tracer HW!");
		t32.ping();
		System.out.println("Status Line: "+t32.getMessage());
		
		
		//exit
		System.out.println(" ************ TEST HARDWARE OK!!!!!!!!!!!");
		System.out.println("END OF TASK!");
		t32.exit();
		
		

	}

}
