/** Rappresenta un file ELF (forse inutile, non lo chiama nessuno)
 *  (non compare nel testo della tesi)
 * 
 */
package cpu;

import java.io.FileNotFoundException;
import java.io.IOException;

/** Rappresenta un file ELF generico
 * @author Pierfrancesco
 *
 */
public abstract class FileELF {
	
		protected String nome_file;
		
		/** Costruttore
		 * @param nome_file		nome del file ELF
		 */
		public FileELF(String nome_file) {
			super();
			this.nome_file = nome_file;
		}

		/** Apre il file ELF
		 * @throws FileNotFoundException 
		 * 
		 */
		public abstract void open() throws FileNotFoundException;
		
		/** Chiude il file ELF
		 * @throws IOException 
		 * 
		 */
		public abstract void close() throws IOException;
		
		
		/** Controlla se l'istruzione corrente e' un jump
		 * @return			true se l'istruzione corrente e' un jump (qualunque)
		 */
		public abstract boolean isCurrJump();
		
		/** Controlla se l'istruzione corrente e' un jump condizionale
		 * @return			true se l'istruzione corrente e' un jump condizionale
		 */
		public abstract boolean isCurrCondJump();
		
		/** Legge l'istruzione corrente
		 * 
		 */
		public abstract void read();
		
		/** Si sposta sull'istruzione successiva
		 * 
		 */
		public abstract void next();
		
}
