// per il momento questa non serve
/**
 * 
 */
package cpu.nios2;

import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import cpu.FileELF;

/**
 * @author Pierfrancesco
 *
 */
public class FileELF4Nios2 extends FileELF{
	
	private DataInputStream file_descr;		// descrittore del file da utilizzare
	private long curr_addr;					// indirizzo corrente
	private long curr_instr;					// istruzione corrente
	private long curr_dest;					// destinazione del jump corrente
	//private int curr_length;				// lunghezza dell'istruzione corrente
	private long curr_opcode;				// opcode corrente
	//private long last_addr;					// ultimo indirizzo

	//private long start_addr;
	private long end_addr;
	
	
	

	/**
	 * @return Returns the curr_dest.
	 */
	public long getCurr_dest() {
		return curr_dest;
	}


	/**
	 * @return Returns the curr_opcode.
	 */
	public long getCurr_opcode() {
		return curr_opcode;
	}


	/** Costruttore di default
	 * @param file_descr
	 * @param curr_addr
	 * @param curr_instr
	 * @param curr_dest
	 * @param curr_length
	 * @param curr_opcode
	 * @param last_addr
	 */
	public FileELF4Nios2( String nome_file, long start, long end ) {
		super(nome_file);
		this.file_descr = null;
		this.curr_addr = 0;
		this.curr_instr = 0;
		this.curr_dest = 0;
		//this.curr_length = 0;
		this.curr_opcode = 0;
		//this.last_addr = 0;
		//this.start_addr=start_line;
		this.end_addr=end;
		
	}
	

	/* (non-Javadoc)
	 * @see cpu.FileELF#open()
	 */
	public void open() throws FileNotFoundException {
		File file = new File(this.nome_file);
		FileInputStream fs = new FileInputStream(file);
		BufferedInputStream bs = new BufferedInputStream(fs);
		this.file_descr = new DataInputStream(bs);
	}

	/* (non-Javadoc)
	 * @see cpu.FileELF#close()
	 */
	public void close() throws IOException {
		this.file_descr.close();
	}

	/* (non-Javadoc)
	 * @see cpu.FileELF#isCurrJump()
	 */
	public boolean isCurrJump() {
		long t_opcode;
		t_opcode=this.curr_instr & Nios2CPU.MASK_OPCODE_JUMP;
		// this.curr_opcode= shiftare t_opcode di 8 bit a destra
		this.curr_opcode= t_opcode >> 8;
		
		long imm16;
		// maschero i bit della destinazione
		imm16=(this.curr_instr & Nios2CPU.MASK_DEST_JUMP) >> 6;
		// li shifto a destra di 6 bit per averli allineati
		// TODO:  estendere il segno dell'operando e sommarlo all'indirizzo successivo
		this.curr_dest= ((imm16 <<10) >>>16)+ this.curr_addr+Nios2CPU.lengthInstr();
		return Nios2CPU.isJump(this.curr_opcode);
	}

	/* (non-Javadoc)
	 * @see cpu.FileELF#isCurrCondJump()
	 */
	public boolean isCurrCondJump() {
		long t_opcode;
		t_opcode=this.curr_instr & Nios2CPU.MASK_OPCODE_JUMP;
		// this.curr_opcode= shiftare t_opcode di 8 bit a destra
		this.curr_opcode= t_opcode >> 8;
		long imm16;
		// maschero i bit della destinazione
		imm16=(this.curr_instr & Nios2CPU.MASK_DEST_JUMP) >> 6;
		// li shifto a destra di 6 bit per averli allineati
		this.curr_dest= ((imm16 <<10) >>>16)+ this.curr_addr+Nios2CPU.lengthInstr();
		return Nios2CPU.isCondJump(this.curr_opcode);
		
	}

	/* (non-Javadoc)
	 * @see cpu.FileELF#read()
	 */
	public void read() {
		
	}

	/* (non-Javadoc)
	 * @see cpu.FileELF#next()
	 */
	public void next() {
		//this.last_addr=this.curr_addr;
		//this.curr_length=Nios2CPU.lengthInstr();
		this.curr_addr +=Nios2CPU.lengthInstr();
		// ...continua
	}


	/**
	 * @return Returns the curr_addr.
	 */
	public long getCurr_addr() {
		return curr_addr;
	}
	
	public boolean isEnd() {
		if (this.curr_addr==this.end_addr)
			return true;
		else
			return false;
		
	}
	
}
