/**
 * 
 */
package general.utils;

import java.util.LinkedList;
import cpu.nios2.*;
/**
 * @author Pierfrancesco
 *
 */
public class Division {
	
	private class Blocco {
		
		public int	start;
		public int end;
		public Blocco link1;
		public Blocco link2;
		
		public Blocco(int s, int e) {
			
			this.start=s;
			this.end=e;
			this.link1=null;
			this.link2=null;
			
		}
		
	
			
		}
	
	
	
	LinkedList lista_blocchi;
	
	public Division(int start, int end) {
		if (start<=end) {
			this.lista_blocchi=new LinkedList();
			Blocco b=new Blocco(start, end);
			this.lista_blocchi.addFirst(b);
		}
	}
	
	public void insert(int indirizzo) {
		for (int i=0;i<this.lista_blocchi.size();i++) {
			Blocco b=(Blocco) this.lista_blocchi.get(i);
			if ( (indirizzo>=b.start) & (indirizzo<=b.end) ) {
				// se l'indirzzo e' compreso tra inizio e fine
				// alloco un nuovo blocco
				Blocco nuovo=new Blocco(indirizzo,b.end);
				// prendo i vecchi link e li metto sul nuovo blocco
				nuovo.link1=b.link1;
				nuovo.link2=b.link2;
				b.link1=nuovo;
				b.link2=null;
				b.end=indirizzo-Nios2CPU.lengthInstr();
				// lo inserisco alla fine della lista
				this.lista_blocchi.addLast(nuovo);
				break;
				
			}// if
	
		} // for
		
	} // insert

	public void stampa() {
		System.out.println("LISTA DEI BLOCCHI DI * DIVISION *");
		for (int i=0;i<this.lista_blocchi.size();i++) {
			Blocco b=(Blocco) this.lista_blocchi.get(i);
			System.out.print("BLOCCO DA 0x"+Integer.toHexString(b.start));
			System.out.println(" A 0x"+Integer.toHexString(b.end)  );
			
			
			
		}
		
		
	}
	
	
}
