// commentata
package general.utils;


/** Rappresenta un contenitore di numeri unici
 * @author Pierfrancesco
 *
 */
public class UniqueNumber {
	
	private final int START_NUM=1000;

	private int number;		// limitato a 4MLD se si vuole incrementare
							// si puo' usare long invece di int
												
	/** Costruttore di default
	
	*/										
	public UniqueNumber() {
		
		this.number=START_NUM;
	}
	
	/** Costruttore
	 * @param			numero da cui iniziare
	 */
	public UniqueNumber(int start) {
		
		this.number=start;
	}
	
	/** Restituisce un numero univoco relativo all'istanza della classe
	 *	@return					numero univoco
	 */
	public int number() {
		
		this.number++;
		return number;
		
	}
	
	/** Restituisce un numero (come stringa) univoco relativo all'istanza della classe
	 *	@return 				numero univoco (come stringa)
	 */
	public String str_number() {
		String s;
		this.number++;
		s=Integer.toString(this.number);
		return s;
		
	}
	
	
}