package testcase;
// questo per il momento non serve al progetto
// non considerare ai fini della tesi


/** Contiene un vettore di booleani (condizioni per i jump)
 *  e per provare tutte le combinazioni di booleani
 * @author Pierfrancesco
 *
 */
public class Conditions {
	
	private long long_value;
	private boolean[] cond;
	private int length;
	
	/** Costruttore
	 * @param length		numero di booleani ( o di jump condizionali)
	 */
	public Conditions(int n) {
		// limitata per il momento a 64 boolean
		if (n>=64)
			n=63;
		this.length = n;
		this.long_value=0;
		this.cond=new boolean[n];
		
		// lo riempio di zeri all'inizio
		for(int i=0;i<=(this.length-1);i++)
			this.cond[i]=false;
		
	}
	
	/** Scorre tutti i possiibli valori per il vettore di booleani
	 * @param c		vettore di booleani
	 * @return 		-1 se si e' arrivati alla fine, 0 altrimenti
	 */
	public int next(boolean[] c) {
		
		if (this.long_value>Math.pow(2,this.length)-1)
			return -1;
		
		this.long_value++;
		
		String s=new String(Long.toBinaryString(this.long_value));
		int max=this.length-s.length();
		//aggiungo gli zeri in testa
		StringBuffer zeros=new StringBuffer("");
		for(int k=1;k<=max;k++) 
			zeros.append('0');
		
		
		String s2=zeros+s;
		
		for(int i=0;i<=(this.length-1);i++)
			if (s2.charAt(i)=='1')
				this.cond[i]=true;
			else
				this.cond[i]=false;
		System.arraycopy(this.cond,0,c,0,this.length);
		
		return 0;
		
	}
	
	/** restituisce il vettore di booleani
	 * @return
	 */
	public boolean[] value(){
		//System.arraycopy(this.cond,0,c,0,this.length);	
		return this.cond;		
	}
	
	
	
}
