// Prova per distinguere se c'e' una call o una ret

import general.Tracer;

import com.lauterbach.trace32.api.Trace32Exception;

import cpu.nios2.analyzer.record.ARecord4NiosII;

/**
 * 
 */

/**
 * @author Pierfrancesco
 *
 */
public class ProvaTimingCall {

	/**
	 * @param args
	 * @throws Trace32Exception 
	 */
	public static void main(String[] args) throws Trace32Exception {
		
		Tracer.init();
				
		
		ARecord4NiosII r;
		
		
		for(int i=-1039;i<=-1;i++) {
			r=new ARecord4NiosII(i);
			if (r.isCall() && r.isProgramAccessClass())
				System.out.println("Al record n. "+i+" c' una call");
			if (r.isRet() && r.isProgramAccessClass())
				System.out.println("  -  Al record n. "+i+" c'e' la RET");
		
		}
		Tracer.exit();
		

	}

}
