


import general.Tracer;
import analyzer.record.ARecordOnLine;

//import com.lauterbach.trace32.api.Trace32API;
import com.lauterbach.trace32.api.Trace32Exception;

public class ProvaTracer {

	private long length;
	private ARecordOnLine[] array;	//vettore con i vari record come elementi
	
	
	
	public ProvaTracer(int start, int end) throws Trace32Exception {
		int i;
		
		
	
		// start_line=-1
		// end_line= -....
		this.length= (start-end+1);
		
		//e costruisco l'array con i vari elementi
		this.array=new ARecordOnLine[(int) (this.length)];
		
				
		//carico l'array con i vari elementi
		for(i=0;start>=end;i++) 
			this.array[i]=new ARecordOnLine(start--);
		
		
		// QUESTE SONO PROVE PER VEDERE UN PO' COME VANNO LE COSE
		//---------------------------------------------------------------------
		int addrsym=Tracer.t32.getSymbolAddress("ast");
		System.out.println("Indirizzo del simbolo ast :"+addrsym);
		int count=Tracer.t32.readPC();
		System.out.println("Il PC : "+count);
		String sorgente=Tracer.t32.getSourceFile(2204);
		System.out.println("Il file sorgente corrispondente all'indirizzo 2204: "+sorgente);
		int linea=Tracer.t32.getSourceLine(2204);
		System.out.println("Linea di codice del  sorgente corrispondente all'indirizzo 2204: "+linea);
		Tracer.t32.command("trace.coverage.listfunc");
		String mess=Tracer.t32.getMessage();
		System.out.println("Return message :"+mess);
		System.out.println(Tracer.t32.checkedCommand("trace.coverage.listfunc"));
		Tracer.t32.getMessageMode();
		
		//------------------------------------------------------------------
		
		
		
		
		//chiudo la trasmissione
		Tracer.t32.exit();
	}
	
	public void getAddr() {
		long i;
		for(i=0;i<this.length;i++) {
			System.out.print("Address of "+i+"-th elem  record n. "+array[(int) i].getNumRecord());
			System.out.println(" : 0x"+Long.toHexString(this.array[(int) i].getPAddress()));
			
		
		}
	}
}
