//commentata

/**
 * 
 */
package block.codeblock.set;

import general.utils.Utils;

import java.io.PrintWriter;

import block.Block;
import block.codeblock.BlockCode;

/**
 * @author Pierfrancesco
 *
 */
public class SubBlocks extends SetOfPieceOfCode {
	
	
	
	/** Costruttore
	 * 
	 */
	public SubBlocks()  {
		super();
		
	}
	
	
	/** Aggiunge un sub blocco
	 * @param b			sub blocco da aggiungere
	 */
	public void addSubBlock(BlockCode b) {
		
		
		BlockCode curr_block=null;
		int max=this.vettore.size();
		// se non ci sono sub_blocchi lo aggiungo direttamente
		if (max==0)
			this.vettore.add(b);
		else { // se ci sono gia' dei sub_blocchi
			boolean trovato=false;
			int i;
			for(i=0;i<max;i++) {
				curr_block=(BlockCode) this.vettore.get(i);
				// se il blocco b e' interamente contenuto nel blocco corrente
				if ( (b.getStart_line()>=curr_block.getStart_line()) && (b.getEnd_line()<=curr_block.getEnd_line()) ) {
					trovato=true;
					break;
				} //if
			} // for
			if (trovato)
				curr_block.addSubBlock(b);
			else  // se non c'e' un blocco che possa contenerlo
				// allora lo aggiungo alla lista
				this.vettore.add(b);
			
		} //else
	}//method
	
	
	public void xml(int n, PrintWriter file) {
		String tab=Utils.tabs(n);
		file.println(tab+"<SUB_BLOCKS>");
		Block t=null;
		for(int i=0;i<this.vettore.size();i++) {
			t=(Block) this.vettore.get(i);
			t.xml(n+1, file);
		}
		file.println(tab+"</SUB_BLOCKS>");
		
		
	}
	
	
	public void dtd(PrintWriter file) {
		
		file.println("<!ELEMENT Sub_blocks (CodeBlock)+");
		
		
	}
}
