package block.datablock;

import com.lauterbach.trace32.api.Trace32Exception;

import analyzer.record.ARecord;

public class MagicData extends BlockData {
	
	private Object value;
	
	
	


	public MagicData(String name, String nome_file, long start, long end) throws Trace32Exception {
		super(name, start, end);
		this.value=null;
		
	}


	/**
	 * @return Returns the value.
	 */
	public Object getValue() {
		return value;
	}


	/**
	 * @param value The value to set.
	 */
	public void setValue(Object value) {
		this.value = value;
	}
	
	
	public void leggiRecord(ARecord r) {
		
		if ( (r.isReadAccessCycle()) && (r.isDataAccessClass()) )
			System.out.print("READ ");
		else
			System.out.println("WRITE ");
		System.out.println("ACCESS TO VARIABLE: "+this.getName()+" AT RECORD N."+r.getNumRecord()   );
		
	}
	
	
}
